/*
 * MMA7455ģ
 * 
 * ;MMA7455ģԳ
 * 
 * 									ע
 * Huafeng Lin			2010/12/10			
 * Huafeng Lin			2011/08/13			޸
 * 
 */

#include <reg52.h>
#include <intrins.h>

#define uchar unsigned char
#define uint  unsigned int
/***************************************************************************/
/***********               ƬŶ                       ************/
/***************************************************************************/
sbit sda=P0^3;              //I2C ݴλ
sbit scl=P0^4;              //I2C ʱӴλ
sbit rs=P0^2;				//1602RSλ
sbit rw=P0^1;				//1602RWλ
sbit e =P0^0;				//1602E λ

/******************************************************************************/
/**********                     ݲ                            ***********/
/******************************************************************************/
#define IIC_READ  0x1D      //ָ
#define IIC_WRITE 0x1D      //дָ

uchar table1[16]=" LCSOFT  X= 0.00";		//1602ʾ
uchar table2[16]=" Y= 0.00 Z= 0.00";
uchar table3[16]="No acceleration!";
uchar table4[10]="0123456789";
uchar table5[8] =" MMA7455";
uchar table7[16]="Value:   X=0.50 ";

/**************************************************************************/
/************                  ʱ                    **************/
/**************************************************************************/
void iic_delay()        //5usʱ
{
	_nop_();
	_nop_();
	_nop_();
	_nop_();
}

void delay_50us(uint t)
{
    uchar j;
	for(;t>0;t--)
	for(j=19;j>0;j--);
}

void delay_50ms(uchar t)
{
    uint j;
	for(;t>0;t--)
	for(j=6245;j>0;j--);
}

/************************************************************************/
/**************                  1602ʾ           *****************/
/************************************************************************/ 
void  write_com(uchar com)	   //ܣдָ
{
    e=0;
	rs=0;
	rw=0;
	P2=com;
	delay_50us(10);
	e=1;
	delay_50us(20);
	e=0;
}

void write_data(uchar dat)	   //ܣд
{
    e=0;
	rs=1;
	rw=0;
	P2=dat;
	delay_50us(10);
	e=1;
	delay_50us(20);
	e=0;
}

void init1602(void)			   //ܣʼ1602
{
    delay_50us(300);
	write_com(0x38);
	delay_50us(100);
	write_com(0x38);
	delay_50us(100);
	write_com(0x38);
	write_com(0x38);
	write_com(0x01);
	write_com(0x01);
	write_com(0x06);
	write_com(0x0c);
}

/*********************************************************************/
/**************               I2CͨŲ              ***************/
/*********************************************************************/
void iic_start()               //ܣI2Cͨſʼ
{
	sda=1;
    iic_delay();
	scl=1;
    iic_delay();
	sda=0;
	iic_delay();	
}

void iic_stop()                //ܣI2Cֹͨͣ
{
	sda=0;
	iic_delay();
	scl=1;
	iic_delay();
	sda=1;
	iic_delay();	
}

void iic_ack()                 //ܣI2CͨŲӦλ
{	
    sda=1;
	scl=1;
	iic_delay();
	scl=0;	   
}

void iic_write_byte(uchar wdata)	//ܣI2Cӻдһֽ
{
	uchar i,temp,temp1;
	
	temp1=wdata;
	for(i=0;i<8;i++)
	{
		scl = 0;
		iic_delay();
		temp=temp1;
		temp=temp&0x80;
		if(temp==0x80)
			sda=1;				
		else
			sda=0;
		iic_delay();
		scl=1;
		iic_delay();
		scl=0;
		iic_delay();
		temp1=temp1<<1;			
	}
}

char iic_read_byte(void)	//ܣI2Cӻжһֽ
{
	uchar x;
	char data_data;
	for(x=0;x<8;x++)
	{	
		data_data=data_data<<1;
		sda=1;
		iic_delay();
		scl=0;
		iic_delay();
		scl=1;
		iic_delay();
		if(sda==1)
			data_data|=0x01; 
		//else  
		//   data_data&=0xfe;
	}
	return data_data;
}

void iic_write(uchar byte_add,uchar wdata)	//ܣַдһֽ
{
     uchar t;
	 t=(IIC_WRITE<<1);
	 iic_start();
	 iic_write_byte(t);
	 iic_ack();
	 iic_write_byte(byte_add);
	 iic_ack();
	 iic_write_byte(wdata);
	 iic_ack();
	 iic_stop();
}

char iic_read(uchar byte_add)	//ܣַһֽ
{
     uchar t;
	 char x;
	 t=(IIC_WRITE<<1);
	 iic_start();
	 iic_write_byte(t);
	 iic_ack();
	 iic_write_byte(byte_add);
	 iic_ack();
	 t=((IIC_READ<<1)|0x01);
	 iic_start();
	 iic_write_byte(t);
	 iic_ack();
	 x=iic_read_byte();
	 iic_ack();
	 iic_stop();
	 return x;
}

/************************************************************************/
/*************               LEDʾв               **************/
/************************************************************************/

void self_test7455()					 //ܣ7455ûв
{										 //          ûвã1602ʾ
	uchar j;							 //			 No acceleration!"
	char t;

	delay_50us(10);
	iic_write(0x16,0x05);
	delay_50us(20);
	t=iic_read(0x16);

	if(t!=0x05)
	{
		write_com(0x80);
		for(j=0;j<16;j++)
		{
		    write_data(table3[j]);
			delay_50us(10);
		}
		while(1);
	}
	else
	{
		write_com(0x80);
		for(j=0;j<16;j++)
		{
		    write_data(table1[j]);
			delay_50us(10);
		}
		write_com(0x80+0x40);
		for(j=0;j<16;j++)
		{
		    write_data(table2[j]);
			delay_50us(10);
		}
	}
		
}

void sendx()	//ܣ1602x
{	
	uchar x1,x2,x3,xsign;
	char x;

	x=iic_read(0x06);
	if((x&0x80)==0x00)
	{
		xsign=0x2b;        //+
	}
	else
	{
		xsign=0x2d;        //-
		x=x-0x01;
		x=~x;
	}

	x1=(x/63);
	x2=((x*100/63)%100)/10;
	x3=(x*100/63)%10;

	write_com(0x8B);
	write_data(xsign);
	delay_50us(10);
	write_com(0x8C);
	write_data(table4[x1]);
	delay_50us(10);
	write_com(0x8E);
	write_data(table4[x2]);
	delay_50us(10);
	write_com(0x8F);
	write_data(table4[x3]);
	delay_50us(20);
}

void sendy()	//ܣ1602y
{
	uchar y1,y2,y3,ysign;
	char y;

	y=iic_read(0x07);
	if((y&0x80)==0x00)
	{
		ysign=0x2b;        //+
	}
	else
	{
		ysign=0x2d;        //-
		y=y-0x01;
		y=~y;
	}

	y1=(y/63);
	y2=((y*100/63)%100)/10;
	y3=(y*100/63)%10;

	write_com(0xC3);
	write_data(ysign);
	delay_50us(10);
	write_com(0xC4);
	write_data(table4[y1]);
	delay_50us(10);
	write_com(0xC6);
	write_data(table4[y2]);
	delay_50us(10);
	write_com(0xC7);
	write_data(table4[y3]);
	delay_50us(20);
}

void sendz()	//ܣ1602z
{
	uchar z1,z2,z3,zsign;
	char z;

	z=iic_read(0x08);
	if((z&0x80)==0x00)
	{
		zsign=0x2b;        //+
	}
	else
	{
		zsign=0x2d;        //-
		z=z-0x01;
		z=~z;
	}

	z1=(z/63);
	z2=((z*100/63)%100)/10;
	z3=(z*100/63)%10;

	write_com(0xCB);
	write_data(zsign);
	delay_50us(10);
	write_com(0xCC);
	write_data(table4[z1]);
	delay_50us(10);
	write_com(0xCE);
	write_data(table4[z2]);
	delay_50us(10);
	write_com(0xCF);
	write_data(table4[z3]);
	delay_50us(20);
}

/***********************************************************/
/****************                     ****************/
/***********************************************************/

void main()
{
	uchar j;

	init1602();
	self_test7455();

	iic_write(0x10,0x15);//УXֵ
	iic_write(0x12,0x25);//УYֵ
	iic_write(0x14,0x10);//УZֵ

	delay_50ms(20);

	write_com(0x80);
	for(j=0;j<8;j++)
	{
		write_data(table5[j]);
		delay_50us(10);
	}

	while(1)
	{
		sendx();
		delay_50ms(1);
		sendy();
		delay_50ms(1);
		sendz();
		delay_50ms(1);
	}	
}
